C Sets range: no. of intervals and limits for each range of Z, for A 
C given LAMBDA.
C
      SUBROUTINE ZRANGE(LAMBDA,MAX,ZLIM,ZNVAL,
     &     M,A,N,OLDL,ZETA,RTFLG)
      INTEGER INTVL(6,3),ZNVAL(6),IRANG(6),M,N,MAX,RTFLG,PRECIS(6,3)
      REAL A,DUMLAM,OLDL,ZETA,FOCUS,ZLIM(7),LAMBDA,X,AN,RTNM1,
     &     NP1
      DATA IRANG /-6,-4,-2,2,4,6/
      DATA PRECIS /3,3,3,3,3,3,
     & 		   2,2,2,2,2,2,
     & 	 	   1,1,1,1,1,1/
      AN=FLOAT(N)
      NP1=AN+1.0
      RTNM1=SQRT(AN-1.0)
      MAX=6
C
C Find precision required for given LAMBDA.
C
C RTFLG, root flag, shows whether root-finding (=0) or coarse
C grid-forming (=1) is being done. 
C
      IF (RTFLG .EQ. 0) THEN
        J1=1
      ELSE IF (LAMBDA .GT. OLDL) THEN
        WRITE(6,*)'LAMBDA > OLDL IN ZRANGE: WHY???'
        WRITE(6,*)' N = ',N,'LAMBDA = ',LAMBDA,'OLDL = ',OLDL
      ELSE IF (LAMBDA .GT. OLDL-2.0/RTNM1) THEN
        J1=1
      ELSE IF (LAMBDA .GT. OLDL-3.0/RTNM1) THEN
        J1=2
      ELSE
        J1=3
      END IF
      DO 10 I=1,6
        ZNVAL(I)=PRECIS(I,J1)
10    CONTINUE
C
C  2. Find range of intervals: the limits to the intervals for given LAMBDA
C
      IF (LAMBDA .GT. ZETA) THEN
        FOCUS=ZETA
      ELSE
        FOCUS=LAMBDA
      END IF
C
C  ZLIM(4) is FOCUS
C
      ZLIM(4)=FOCUS
C
C  Sets limits
C
      DO 20 I=1,3
          ZLIM(I)=FOCUS+FLOAT(IRANG(I))/AN
20    CONTINUE
C
C  Restricts limits for special cases:
C
      IF (LAMBDA .GE. ZETA) THEN
      	DO 100 I=5,7
      	  ZLIM(I)=0.0
      	  ZNVAL(I-1)=0
100	CONTINUE
      ELSE
      	IF (ZETA .LT. LAMBDA +2.0/AN) THEN
          ZLIM(5)=ZETA
          ZLIM(6)=0.0
          ZLIM(7)=0.0
    	  ZNVAL(5)=0
      	  ZNVAL(6)=0
        ELSE
          ZLIM(5)=LAMBDA+2.0/AN
          IF (ZETA .LT. LAMBDA + 4.0/AN) THEN
            ZLIM(6)=ZETA
            ZLIM(7)=0.0
      	    ZNVAL(6)=0
          ELSE
            ZLIM(6)=LAMBDA+4.0/AN
            IF (ZETA .LT. LAMBDA + 6.0/AN) THEN
              ZLIM(7)=ZETA
            ELSE
              ZLIM(7)=LAMBDA+6.0/AN
C    And no more, stop after encountering this condition!
C    This is the final limit.
            END IF
          END IF
        END IF
      END IF
      RETURN
      END
C
C
C------------------------------------------------------------------
