C FUNCTION FX defines the function to be
C integrated and is used in conjunction with SUBROUTINE ROMBRG
C and a main program.
C
C Called from SUBROUTINE ROMBRG only (and is passed to ROMBRG as
C an argument.
C Calls SUBROUTINE QSIGNS.
C Will call REAL FUNCTION QUAD.
C
      REAL FUNCTION FX(Z,A,N,LAMBDA)
      INTEGER N,NUMMU,NCNT,FLAG
      REAL*4 A,LAMBDA,AN,EXPNT,EPS,Z,PI,OLDL,OLDLAM(200),
     &       OLDQ(200),Q1,Q2,Q3,Z1,Z2,Z3,QZ,EXPNT2,SGN,
     &       MU(2),MUJ,QMU(2),DEN,NUMPT,ZETA
      REAL*8 DTERM,DZ,DN
      LOGICAL QSGN(2)
      COMMON /GRD/ OLDLAM,OLDQ,NCNT
      COMMON /FXFLAG/ FLAG
C  In COMMON with SUBROUTINE SOLVE
      COMMON /SLVFX/ ZETA
C
      DATA NUMMU,AN,EXPNT,OLDL,Q1,Q2,Q3,Z1,Z2,Z3,QZ,MU,QMU /0,14*0.0/
C
C  Quadratic interpolation for Qnstar(Z), or QZ.
C
C  Find LAMBDA(N) in old grid such that two LAMBDA are
C  just less than, and one just more than, Z.
C
C Z is t in the notes (11-84). Perhaps it would be clearer if all z's
C   were changed to t's (except where should be MU(J)=MUJ).
C
      FLAG=0
      AN=N
      EPSEXP=1.0E-20
      EPS=1.0E-07
C UNKNOWN CASE INCLUDES THESE LINES:
C
      CALL QSIGNS(QSGN)		!
C      QSGN(1)=.TRUE.		!
C      QSGN(2)=.TRUE.		!
C Useful if occurs fairly often:
      IF (.NOT. QSGN(1) .AND. .NOT. QSGN(2)) THEN  
      	FX=0.0
C      WRITE(6,*)' FX: Q(-) & Q(+) ARE SET TO 0.0'
C      WRITE(6,*)' T = ',Z,'N = ',N
      	RETURN
      END IF
C      PRINT *,'AN=',AN,'  Z=',Z
      DEN=SQRT((AN-1.0+Z*Z)/AN)
      NUMPT=Z/SQRT(AN*(AN+1.0))
      DO 20 J=1,2
C Calculate Qneg & Qpos, call them QMU(J)
      	IF ( .NOT. QSGN(J) ) THEN
      	  QMU(J)=0.0
C      	   WRITE(6,*)'QSGN(J) is ',QSGN(J),'  FOR J =',J
      	  GOTO 20
      	END IF
      	SGN=SIGN(1.0,REAL(J)-1.5)
      	MU(J)=(LAMBDA+SGN*NUMPT)/DEN
        MUJ=MU(J)
C      WRITE(6,*)' J = ',J,' N= ',N,'  T = ',Z,' MUJ = ',MUJ,
C     &  ' LAMBDA = ',LAMBDA,' SGN = ',SGN,' NUMPT = ',NUMPT,
C     &  ' DEN = ',DEN
        IF (MUJ .LT. OLDLAM(2)) THEN
          QMU(J)=-MUJ/(1.0-A)      
          GO TO 20
        END IF
      	IF (MUJ .GT. ZETA) THEN
          QMU(J)=0.0
          GOTO 20
      	END IF
        DO 10 I=3,NCNT
C   28=10+8+6+4+0+0 IN LRANGE
C
          OLDL=OLDLAM(I)
          IF (ABS(MUJ-OLDL) .LT. EPS) THEN
            QMU(J)=OLDQ(I)
            GOTO 20
          ELSE IF (MUJ .LT. OLDL) THEN
            NUMMU=I
            GO TO 100
          END IF
10      CONTINUE
C
C MUJ > ALL OLD LAMBDA IN FX. Therefore, set Q(MUJ) = 0. MUJ is beyond
C the upper limit of integration. This limit is actually XI (= ZETA in
C this program; the equivalent of ZETA in the known variance case), 
C which is the upper limit for the coarse grid of old 'LAMBDAs'. If MUJ
C passes through the above DO-loop to the following statement, then it
C is beyond the upper limit of integration.
C
C      WRITE(6,*)'MUJ > ALL OLD LAMBDA IN FX.',' QMU(J) SET TO 0.0'
C      WRITE(6,*)'MUJ= ',MUJ,'      NCNT = ',NCNT
C      WRITE(6,*)'N= ',N,'      LAMBDA = ',LAMBDA,'     T = ',Z
C      WRITE(6,*)'OLDL GRID = ',(OLDLAM(IOLD),IOLD=1,NCNT)
C
        QMU(J)=0.0
        GOTO 20
C      
C
C The next line stops the program with an error message & gives a
C symbolic stack dump (which traces the subroutine calls for the 
C current position.
C
C      ERROR=ERROR/ERROR
C      STOP 'IN FX: ERROR'
100   CONTINUE
C  QMU(J)=QUAD(NUMMU,MUJ)
C  REAL FUNCTION QUAD(NUM,MU)//INTEGER NUM//REAL OLDLAM()...//COMMON/GRD/..
      Z1=OLDLAM(NUMMU-2)
      Z2=OLDLAM(NUMMU-1)
      Z3=OLDLAM(NUMMU)
      Q1=OLDQ(NUMMU-2)
      Q2=OLDQ(NUMMU-1)
      Q3=OLDQ(NUMMU)
C calculate Q(MU(J)) by quadratic interpolation.
C
C
      QMU(J)=Q3*(MUJ-Z1)*(MUJ-Z2)/((Z3-Z1)*(Z3-Z2))
     &     + Q1*(MUJ-Z2)*(MUJ-Z3)/((Z1-Z2)*(Z1-Z3))
     &     + Q2*(MUJ-Z1)*(MUJ-Z3)/((Z2-Z1)*(Z2-Z3))
C
C Complete the calculation of the integrand.
C
C COULD CHANGE QMU(J) INTO A CALL ON FUNCTION QUAD(MU(J)).
C PERHAPS THIS WOULD BE CLEARER.
C
20    CONTINUE
      DZ=DBLE(Z)
      DN=DBLE(N)      
      DTERM=(1.0D0+DZ*DZ/(DN-1.0D0))**(-0.5D0*DN)
C
C This routine would be more efficient if the following test occurred 
C before calculating QMU(J), modified to RETURN if TRUE, else to proceed, 
C calculating QMU(J), then FX.
C
      IF (ABS(DTERM) .LT. EPSEXP) THEN
        FX=0.0
        FLAG=1
      ELSE
        FX=(QMU(1)+QMU(2))*DEN*DTERM
      END IF
C      WRITE(6,*)'FX: END. FX = ',FX,' QMU(1),(2) = ',QMU(1),QMU(2)
C      WRITE(6,*)' DTERM = ',DTERM,' DEN = ',DEN, ' FLAG = ',FLAG
      RETURN
      END
C WOULD BE CLEARER IF REMOVE QUAD INTERP TO SEPARATE FUNCTION ---------
