C Called from SUBROUTINE SOLVE only.
C Calls no subprograms.
C
      SUBROUTINE TROOT(N,ZETA,LAMBDA,DDELTA,NROOTS,NFRMLA,T1,T2)
C
      INTEGER NROOTS,NFRMLA,N
      REAL*4 T0,T1,T2,TF,ZETA,LAMBDA,DELTA,RN,RL,Z,D,FACTOR,DIV,GN,
     &       CASEH,EPS,NEGSQT 
      REAL*8 DDELTA
C Three STATEMENT FUNCTIONS follow for intermediate calculations.
      FACTOR(RN)=SQRT(RN*(RN+1.0))
      DIV(RN)=(RN-1.0)/RN
      GN(Z,RN,RL,D)=Z*SQRT((RN+1.0)*RL*RL+DIV(RN)*D)
C
      DELTA=REAL(DDELTA)
      RN=REAL(N)
      GOTO (500,1000,2000,3000,1000), NFRMLA+1
500   CONTINUE
C      WRITE(6,*)'TROOT: NO REAL ROOTS. NFRMLA = ',NFRMLA
C      WRITE(6,*)'DELTA = ',DELTA,' N = ',N,' LAMBDA = ',LAMBDA,' ZETA =
C     &  ',ZETA
      RETURN                  			! No real roots.
1000  CONTINUE
C
C To prevent negative square root in TROOT in calculation of 
C   GN. If true, then no real roots. Not in John's notes. case (h)
C      CASEH=(RN+1.0)*LAMBDA*LAMBDA+DELTA*(RN-1.0)/RN
      NEGSQT=(RN+1.0)*LAMBDA*LAMBDA+DIV(RN)*DELTA
      EPS=3.0E-07*(RN+1.0)*LAMBDA*LAMBDA
      IF (NEGSQT .LT. EPS) THEN 
      	WRITE (*,9000) NEGSQT
      	RETURN            ! case (h)
      END IF
      T0=GN(ZETA,RN,LAMBDA,DELTA) 		! Formula No. 1
      TF=FACTOR(RN)
      T1=(LAMBDA-T0)*TF/DELTA
      IF (NFRMLA .EQ. 4) GOTO 4000		!  goto Formula No. 4
C      WRITE(6,*)'TROOT: ONE REAL ROOT. NFRMLA = ',NFRMLA
C      WRITE(6,*)'DELTA = ',DELTA,' N = ',N,' LAMBDA = ',LAMBDA,
C     &          ' ZETA = ',ZETA,'T1 = ',T1
      RETURN
2000  CONTINUE
      T1=-ZETA*SQRT(DIV(RN))*FACTOR(RN)/SQRT(DELTA)	! Formula No. 2
C      WRITE(6,*)'DELTA = ',DELTA,' N = ',N,' LAMBDA = ',LAMBDA,
C     &          ' ZETA = ',ZETA,'T1 = ',T1
      RETURN
3000  CONTINUE
      T1=LAMBDA*LAMBDA-ZETA*ZETA*DIV(RN)*FACTOR(RN)/(2.0*LAMBDA) !Formula No. 3
C      WRITE(6,*)'DELTA = ',DELTA,' N = ',N,' LAMBDA = ',LAMBDA,
C     &          ' ZETA = ',ZETA,'T1 = ',T1
      RETURN
4000  CONTINUE
      T2=(LAMBDA+T0)*TF/DELTA		! Formula No. 4 after No.1 evaluated 
      IF (T2 .GT. T1) STOP 'IN TROOT: T2>T1, impossible!'
C      WRITE(6,*)'DELTA = ',DELTA,' N = ',N,' LAMBDA = ',LAMBDA,
C     &          ' ZETA = ',ZETA,' T1 = ',T1,' T2 = ',T2
      RETURN
9000	FORMAT(' ','NEGATIVE ARGUMENT FOR SQUARE ROOT: ',G20.10)
      END
